module Sluggable
	extend ActiveSupport::Concern

	included do
		before_save :set_slug
		class_attribute :slug_column
	end

	def generate_slug
		str = self.send(self.class.slug_column.to_sym)
     	str = str.gsub /\W/, "-"
    	str = str.downcase 

     	post = self.class.find_by slug: str
     	count = 2
     	while post && post != self do
     		checkstr = str + "-" + count.to_s
     		post = self.class.find_by slug: checkstr
     		count = count + 1
     	end

     	if count == 2
     		return str
     	else 
     		count -= 1
     		str = str + "-" + count.to_s
     		return str
     	end
     end

     def set_slug
     	self.slug = generate_slug
     end

    def to_param
    	self.slug
    end

    module ClassMethods
    	def sluggable_column(column)
    		self.slug_column = column
    	end
    end

end